local C = require("classic")
local M = require("menu")
local T = require("toolbox")

function game_fakestart()
	mod_enabled = false
	T.DeleteHook("CREATURE_SQUELCH", "heroes_c_d" , creature_damage_f)
	--print("Please, use Heroes mod...") --(lol)
end

function game_start()
	mod_enabled = true
	
	C.i_gem = i_old_gem
	
	print("-= Heroic battle begins =-")
	
	T.RegisterHook("CREATURE_SQUELCH", "heroes_c_d" , creature_damage_f)
	
	T.AL_DeleteListener("GAME_START", "Heroes_GS")
	T.AL_AddListener("GAME_START", "Heroes_FGS", game_fakestart)
end

function get_hero(hero)
	for i=1,#heroes do
		if heroes[i][1] == hero then
			return i
		end
	end
	table.insert(heroes, {hero, 0, false, -1})
	return #heroes	
end

function on_gem_pickup()
	if kts.GetNumHeld(cxt.actor, i_revive_gem)==1 then --Didn't he already have a gem?
		local i = get_hero(cxt.originator)
		heroes[i][3] = true
		local count = get_barb_gem_at(cxt.pos)
		kts.FlashMessage("Picked up a reviving gem!")
	else
		kts.Drop(i_revive_gem) --Drop previous gem, pickup a new one
	end
end

function on_gem_drop()
	kts.Delay(10) --if gem drop was not caused by death - we will be able to detect this. Btw, "drop gem" action is now unused, but who knows...
	if kts.IsAlive(cxt.actor) then
		local i = get_hero(cxt.originator)
		if (heroes[i][3] and kts.GetNumHeld(cxt.actor, i_revive_gem)<1) then
			heroes[i][3] = false
		end
	else 
	end
end

function set_barb_gem_at(pos)
	for i=1,#barb_gems do
		if (barb_gems[i][1].x == pos.x and barb_gems[i][1].y == pos.y) then
			barb_gems[i][2] = barb_gems[i][2]+1
			return
		end
	end	
	table.insert(barb_gems, {pos, 1})
end

function get_barb_gem_at(pos)
	for i=1,#barb_gems do
		if (barb_gems[i][1].x == pos.x and barb_gems[i][1].y == pos.y) then
			local t = barb_gems[i][2]
			barb_gems[i][2] = 0
			return t
		end
	end	
	return 1
end