local C = require("classic")
local M = require("menu")
local T = require("toolbox")


local Heroes = { --Declare new Quest type
      name = "Heroic Quest",
      description = function(S)
         return "Heroes [WIP]\n\n"
            .. "Pick up 6 barbaric gems to win"
            .. "\n"
            .. "This mod is provided by ImpassIve_rus.\n\n"
      end,
      settings = { 
         mission = "heroes",
         book = "none",
         wand = "none",
         num_wands = 0,
         num_gems = 3,
         gems_needed = 0,
         dungeon = "big",
         premapped = true,
         entry = "close",
         gear = "none",
         exit = "none",
         num_keys = 1,
         pretrapped = true,
         stuff = 5,
         stuff_respawn = "none",
         zombies = 5,
         bats = 4
      }
   }
   
C.quest_table.Heroes = Heroes --Add this new quest type to the quests table
table.insert(C.quest_order, "Heroes") --Put it's name into another table

Quest_Heroes = { --Declare a selection (in menu) for this quest
    id = "Heroes",
    text = Heroes.name,
    min_players = Heroes.min_players,
    max_players = Heroes.max_players,
    min_teams = Heroes.min_teams,
    max_teams = Heroes.max_teams
}
Mission_Heroes = { --Declare new Mission type
    id = "heroes",
    text = "Heroes",
    constrain = function(S)
        S.Is("quest", "Heroes")
        S.Is("exit", "none")
        S.Is("book", "none")
        S.Is("stuff_respawn", "none")
        S.Is("gems_needed", 0)
        S.IsNot("zombies", 0)
        S.IsNot("bats", 0)
        S.IsNot("wand", "securing")
        S.IsNot("dungeon", "tiny")
	end,
	features = function(S)
		T.AL_DeleteListener("GAME_START", "Heroes_FGS")
		T.AL_AddListener("GAME_START", "Heroes_GS", game_start)
		start_heroes()
    end
}
M.add_menu_choice("quest", Quest_Heroes)--Add the quest to menu
M.add_menu_choice("mission", Mission_Heroes)--Add the mission to menu
